Index: main/rtp.c
===================================================================
--- main/rtp.c	(revision 47050)
+++ main/rtp.c	(working copy)
@@ -835,6 +835,11 @@
 			ast_log(LOG_WARNING, "RTCP Read error: %s\n", strerror(errno));
 		if (errno == EBADF)
 			CRASH;
+		/* Hangup so we don't end up in an error loop */
+		if (errno != EAGAIN) {
+			ast_log(LOG_WARNING, "RTCP Read error: hanging up now\n");
+			return NULL;
+		}
 		return &ast_null_frame;
 	}
 
@@ -1123,6 +1128,11 @@
 			ast_log(LOG_WARNING, "RTP Read error: %s\n", strerror(errno));
 		if (errno == EBADF)
 			CRASH;
+		/* Hangup so we don't end up in an error loop */
+		if (errno != EAGAIN) {
+			ast_log(LOG_WARNING, "RTP Read error: hanging up now\n");
+			return NULL;
+		}
 		return &ast_null_frame;
 	}
 	
